#! /bin/sh

OSTYPE=`uname -s`
CURDIR=`pwd`
clear   
echo ""
echo "THIS SCRIPT WILL UNINSTALL CLIWIN, ELM, EVM"
echo ""

if [ "$CURDIR" != "/tmp" ]; then
   cp $CURDIR/uninstall.sh /tmp/evmuninstall.sh
   cd /tmp
   /tmp/evmuninstall.sh
fi

cd /tmp
if [ "$CURDIR" = "/tmp" ]; then
if [ $OSTYPE = "SunOS" ]; then

   #grep pkginfo for CPQevm, CPQelm, CPQcliwin
   #check for previous install of elm, cliwin, evm

   echo ""
   echo "Checking to see if you have installed CLIWIN, ELM, or EVM..\c"

   preelm=`pkginfo | grep CPQelm | cut -d' ' -f2`
   echo ".\c"
   precliwin=`pkginfo | grep CPQcliwin | cut -d' ' -f2`
   echo ".\c"
   preevm=`pkginfo | grep CPQevm | cut -d' ' -f2`
   echo ".\c"
   preswcc=`pkginfo | grep CPQhsg80 | cut -d' ' -f2`
   echo "."
   if [ "$preelm" = "CPQelm" -o "$precliwin" = "CPQcliwin" -o "$preevm" = "CPQevm" ]; then
      echo ""
      echo "The following packages were found on your system. They need to be"
      echo "removed before you continue with the installation."
      echo ""
   if [ "$preelm" = "CPQelm" ]; then
      echo "--> "$preelm
   fi
   if [ "$precliwin" = "CPQcliwin" ]; then
      echo "--> "$precliwin
   fi
   if [ "$preevm" = "CPQevm" ]; then
      echo "--> "$preevm
   fi
   echo ""
   while [ TRUE ]
   do
 	echo ""
 	echo "Consider backing up the jobs directory, log files,"
 	echo "and any other script files that may be in the EVM directory."
 	echo ""
 	echo "Would you like to uninstall now <y/n> \c"

    read type
    if [ "$type" = "y" -o "$type" = "Y" ]; then
       echo ""
       if [ "$precliwin" = "CPQcliwin" ]; then
          clear
          echo "Starting to uninstall CLIwin...."
          pkgrm CPQcliwin
          echo "The CLIwin uninstall has finished."
          sleep 2
          clear
       fi
       if [ "$preelm" = "CPQelm" ]; then
          clear
          echo "Starting to uninstall ELM...."
          pkgrm CPQelm
          echo "The ELM uninstall has finished."
          sleep 2
          clear
       fi
       if [ "$preevm" = "CPQevm" ]; then
          clear
          echo "Starting to uninstall EVM...."
          pkgrm CPQevm
          echo "The EVM uninstall has finished."
          sleep 2
          clear
       fi	     
          echo "The uninstall script has finished"
          echo ""
       break
    elif [ "$type" = "n" -o "$type" = "N" ]; then
         clear
         echo ""
         echo "Aborting the uninstall script."
         echo ""
         exit
    fi
    done
else
   echo ""
   echo "Done."
   echo ""
   echo "CLIWIN, ELM, or EVM not found."
   echo ""
   echo "The uninstall script has finished"
   echo ""
   sleep 2
   clear

fi


elif [ $OSTYPE = "OSF1" ]; then

   echo ""
   echo "Checking to see if you have installed CLIWIN, ELM, or EVM..\c"
   
   tmp=`setld -i | grep CPQCLIWIN100`
   echo ".\c"
   precli=`echo $tmp | cut -d' ' -f2`
   echo ".\c"
   tmp=`setld -i | grep CPQELM201`
   echo ".\c"
   preelm=`echo $tmp | cut -d' ' -f2`
   echo ".\c"
   tmp=`setld -i | grep CPQEVM110`
   echo ".\c"
   preevm=`echo $tmp | cut -d' ' -f2`
   echo ".\c"
   tmp=`setld -i | grep SWCC500`
   echo ".\c"
   preswcc=`echo $tmp | cut -d' ' -f2`
   echo "."


   if [ "$preelm" = "installed" -o "$precliwin" = "installedn" -o "$preevm" = "installed" ]; then
      echo ""
      if [ "$precli" = "installed" ]; then
         echo "--> CLIwin"
      fi
      if [ "$preelm" = "installed" ]; then
         echo "--> ELM"
      fi
      if [ "$preevm" = "installed" ]; then
         echo "--> EVM"
      fi
    
      echo ""
      while [ TRUE ]
      do
         echo ""
         echo "You may want to backup you jobs directory, log files,"
         echo "and any other script files you may have in the EVM directory."
         echo ""
         echo "Would you like to uninstall the previous kits <y/n> \c"
         read type
         if [ "$type" = "y" -o "$type" = "Y" ]; then
            echo ""
            if [ "$precli" = "installed" ]; then
               clear
               echo "Starting to uninstall CLIwin...."
               setld -d CPQCLIWIN100
               rm -r /usr/opt/CPQcliwin
               echo ""
               echo "The CLIwin uninstall has finished."
               sleep 2
            fi
            if [ "$preelm" = "installed" ]; then
                clear
                echo "Starting to uninstall ELM...."
                setld -d CPQELM201
                rm -r /usr/opt/CPQelm
                rm /compaq/wbem
                rmdir /compaq
                echo ""
                echo "The ELM uninstall has finished."
                sleep 2
            fi
            if [ "$preevm" = "installed" ]; then
                clear
                echo "Starting to uninstall EVM...."
                setld -d CPQEVM110
                rm -r /usr/opt/CPQevm
                echo ""
                echo "The EVM uninstall has finished."
                sleep 2
            fi
            break
         elif [ "$type" = "n" -o "$type" = "N" ]; then
            echo ""
            echo "Aborting the uninstall script."
            echo ""
            exit
         fi
      done
   else
   echo ""
   echo "Done."
   echo ""
   echo "CLIWIN, ELM, or EVM not found."
   echo ""
fi
echo ""
echo "The uninstall script has finished."
echo ""
fi

fi
