#! /bin/sh
#
# 
# *****************************************************************
# *                                                               *
# *    Copyright (c) Compaq Computer Corporation, 1997-2001       *
# *                                                               *
# *   All Rights Reserved.  Unpublished rights  reserved  under   *
# *   the copyright laws of the United States.                    *
# *                                                               *
# *   The software contained on this media  is  proprietary  to   *
# *   and  embodies  the  confidential  technology  of  Digital   *
# *   Equipment Corporation.  Possession, use,  duplication  or   *
# *   dissemination of the software and media is authorized only  *
# *   pursuant to a valid written license from Digital Equipment  *
# *   Corporation.                                                *
# *                                                               *
# *   RESTRICTED RIGHTS LEGEND   Use, duplication, or disclosure  *
# *   by the U.S. Government is subject to restrictions  as  set  *
# *   forth in Subparagraph (c)(1)(ii)  of  DFARS  252.227-7013,  *
# *   or  in  FAR 52.227-19, as applicable.                       *
# *                                                               *
# *****************************************************************
#
#
# Description:    upgrade.sh
#        This script upgrades TIGERCAT into /opt/CPQevm dir.
#               You have to be login as ROOT to run this script.
#

VER=1.1A
EVMPORT=4990
EVMENTRY="/tcp\t\t#EVM"
EVM_LABEL=CPQevm-1.1A
#EVM_LABEL=CPQevm-1.1
#ELM_LABEL=CPQelm-1.6
CLIWIN=CPQcliwin-1.0
CURDIR=`pwd`
TMP=/tmp
OSTYPE=`uname -s`


# default commands
PKGADD="/usr/sbin/pkgadd"
USERNAME=`/usr/ucb/whoami`
FGREP="/usr/bin/fgrep -s"
CLEAR="/usr/bin/clear"

#------------------------------------------------------------------------------
#copyright
#------------------------------------------------------------------------------
copyright () 
{

echo "IMPORTANT - Carefully read the License Terms before proceeding.  The \"more\""
echo "command is used to display the License Terms.  Use <space> to page down,"
echo "<enter> to move one line down, or <b> to page up."
echo 
pause
more licenseTerms.txt
while [ TRUE ]
do 
   echo "If you agree to the terms, press \"A\" then <enter>."
   echo
   echo "If you do not agree to the terms,  press \"D\" then <enter>,  which will "
   echo "also terminate your installation procedure.  If you do not agree to these "
   echo "terms, COMPAQ does not grant you a license to use the Software.  In this case you"
   echo "may not use the Software and you should contact the supplier from which you"
   echo "obtained the Software for instructions on returning the Software for a refund."
   echo
   echo "Do you agree to the terms? <A,d>: \c"
   read continue
   if [ "$continue" = "A" -o "$continue" = "a" -o "$continue" = "" ]; then
      echo
      clear
      echo "Continuing with upgrade...."
      echo
      break
   elif [ "$continue" = "D" -o "$continue" = "d" ]; then
      echo
      echo "Aborting the upgrade script."
      echo
      exit
   fi
done
}

Print_Dots()
{
       echo ".\c"
       sleep 1
       echo ".\c"
       sleep 1
       echo ".\c"
       sleep 1
}

#------------------------------------------------------------------------------
#Pause
#------------------------------------------------------------------------------
pause () {

while [ TRUE ]
do 
   echo "Would you like to continue with the upgrade? <Y,n>: \c"
   read continue
   if [ "$continue" = "y" -o "$continue" = "Y" -o "$continue" = "" ]; then
      echo
      clear
      echo "Continuing with upgrade...."
      echo
      break
   elif [ "$continue" = "n" -o "$continue" = "N" ]; then
      echo
      echo "Aborting the upgrade script."
      echo
      exit
   fi
done


}

#------------------------------------------------------------------------------
#Check if root user
#------------------------------------------------------------------------------
checkuid () {

if [ "$USERNAME" != "root" ]; then
  clear
  echo
  echo "You must be SUPERUSER to run this script!"
  exit 1
else
  clear
  echo "Starting the EVM upgrade."
  echo " "
fi
}


#------------------------------------------------------------------------------
# Check for fca, fcaw, fcapci, hsg80, and fcraid packages and correct versions
#------------------------------------------------------------------------------
CheckDriverVer () {

fca=0
fcaw=0
fcapci=0
hsg80=0
fcraid=0


#set -x
#Determine the platform running
if [ $OSTYPE = "SunOS" ]; then
   echo "Checking for the required drivers..\c"
   pkgtmp=`pkginfo | grep CPQ | $CURDIR/pkg_ver_check.awk`
   fca=`echo $pkgtmp | cut -b1`
   echo ".\c"
   fcaw=`echo $pkgtmp | cut -b2`
   echo ".\c"
   fcapci=`echo $pkgtmp | cut -b3`
   echo ".\c"
   hsg80=`echo $pkgtmp | cut -b4`
   echo ".\c"
   fcraid=`echo $pkgtmp | cut -b5`
   echo "."
   echo
   error="0"
   reqdriver="2.5.9"
   if [ "$fca" = "1" ]; then
      verfca=`pkginfo -l CPQfca | grep VERSION:` 
      verfca=`echo $verfca | cut -d' ' -f2`

      i=`expr "$verfca" \>= "$reqdriver"`
      if [ "$i" = 1 ]; then

#      if [ "$verfca" -ge "$reqdriver" ]; then
         echo "Found SBUS 32bit adapter JNI driver version "$verfca 
         echo
      else
         error="1"
         echo "Found SBUS 32bit adapter JNI driver version "$verfca 
         echo
         echo "\tWarning:This installation of EVM requires JNI driver"
         echo "\tverisons 2.5.9 or higher."
         echo
     fi 
   fi   
   
   if [ "$fcaw" = "1" ]; then
      verfcaw=`pkginfo -l CPQfcaw | grep VERSION:`
      verfcaw=`echo $verfcaw | cut -d' ' -f2`

      i=`expr "$verfcaw" \>= "$reqdriver"`
      if [ "$i" = 1 ]; then

      #      if [ "$verfcaw" -ge "$reqdriver" ]; then
         echo "Found SBUS 64bit adapter JNI driver version "$verfcaw 
         echo
      else
         error="1"
         echo "Found SBUS 64bit adapter JNI driver version "$verfcaw 
         echo
         echo "\tWarning:This installation of EVM requires JNI driver"
         echo "\tverisons 2.5.9 or higher." 
         echo
      fi
   fi   
   
   if [ "$fcapci" = "1" ]; then
      verfcapci=`pkginfo -l CPQfcaPCI | grep VERSION:`
      verfcapci=`echo $verfcapci | cut -d' ' -f2`

      i=`expr "$verfcapci" \>= "$reqdriver"`
      if [ "$i" = 1 ]; then

#      if [ "$verfcapci" -ge "$reqdriver" ]; then
         echo "Found PCI 64bit adapter JNI driver version "$verfcapci
         echo
      else
         error="1"
         echo "Found PCI 32bit adapter JNI driver version "$verfcapci
         echo
         echo "\tWarning:This installation of EVM requires JNI driver"
         echo "\tverisons 2.5.9 or higher." 
         echo
      fi
   fi 
 # if [ $fca = "1" -o $fcaw = "1" -o $fcapci = "1" -a "$error" = "1" ]; then
   if [ "$error" = "1" ]; then
      echo
      echo "A separate upgrade to the JNI driver is required."
      echo "Aborting install."
      echo
      exit 1
   elif [ $fca = "1" -o $fcaw = "1" -o $fcapci = "1" -a "$error" = "0" ]; then
      echo "Required driver found, continuing with the installation...."
      echo
     sleep 4
   fi
   if [ $fca = "0" -a $fcaw = "0" -a $fcapci = "0" ]; then
      echo "\tWARNING - There is no JNI driver installed - WARNING"
      echo
      echo "\tThis installation of EVM requires JNI driver"
      echo "\tverisons 2.5.9 or higher."
      echo
      echo
      echo "A separate upgrade to the JNI driver is required."
      echo "Aborting install."
      echo
      exit 1
   fi  
elif [ $OSTYPE = "OSF1" ]; then
   clear
   echo "Continuing with the install...."
   echo
   echo "Checking the version of the KGPSA drivers..\c"
   tmp=`/usr/sbin/uerf -Rr 300 | grep KGPSA`
   echo ".\c"
   ver=`echo $tmp | cut -d' ' -f5`
   echo "."
   echo
   if [ "$ver" = "1.22" ]; then
      echo "Correct KGPSA driver found ver 1.22"
      echo
      echo
      sleep 3
   else
      echo "Can't find the correct ver of the KGPSA driver"
      echo
      echo ">>>>>>>>>>WARNING<<<<<<<<<<"
      echo
      echo "Before you can run EVM."
      echo "You need to check your version of the KGPSA driver,"
      echo "to see if it is compatible with EVM."
      echo
      pause
   fi
fi
}
#------------------------------------------------------------------------------
#  previous install of evm, elm, cliwin, swcc for solaris
#------------------------------------------------------------------------------
solarispreinstallcheck () {

echo "Checking for previous installations..\c"
pkgtmp=`pkginfo | grep CPQ | $CURDIR/evm_elm_cli_check.awk`
EVM=`echo $pkgtmp | cut -b1`
echo ".\c"
ELM=`echo $pkgtmp | cut -b2`
echo ".\c"
CLI=`echo $pkgtmp | cut -b3`
echo "."
echo
error="0"

#if [ "$CLI" = "1" ]; then
#   echo "CLI Script Window not included with EVM 1.1A, leaving existing version."
#fi

# Check if selective upgrade of evm/elm is possible.
if [ "$EVM" = "1" ]; then
   EVMVER=`pkginfo -l CPQevm | grep VERSION:` 
   EVMVER=`echo $EVMVER | cut -d' ' -f2`
   EVMDIR=`pkginfo -l CPQevm | grep BASEDIR:` 
   EVMDIR=`echo $EVMDIR | cut -d' ' -f2`
fi

if [ "$ELM" = "1" ]; then
   ELMVER=`pkginfo -l CPQelm | grep VERSION:` 
   ELMVER=`echo $ELMVER | cut -d' ' -f2`
   ELMDIR=`pkginfo -l CPQelm | grep BASEDIR:` 
   ELMDIR=`echo $ELMDIR | cut -d' ' -f2`
fi

if [ "$EVM" = "1" -a "$EVMVER" = "1.1" ]; then
    UPGRADE_POSSIBLE_FLAG="TRUE"
    echo "Detected EVM version 1.1."
else
    UPGRADE_POSSIBLE_FLAG="FALSE"
fi

if [ "$ELM" = "1" ]; then
    if [ "$ELM" = "1" -a "$ELMVER" = "1.6" -a "$UPGRADE_POSSIBLE_FLAG" = "TRUE" ]; then
        UPGRADE_POSSIBLE_FLAG="TRUE"
        echo "Detected Elm version 1.6."
    else
        UPGRADE_POSSIBLE_FLAG="FALSE"
    fi
fi


type=""
if [ "$UPGRADE_POSSIBLE_FLAG" = "TRUE" ]; then
   while [ TRUE ]
   do
       echo
       echo "If you upgrade, only the EVM binary and supporting files"
       echo "will be overwritten.  All job files, logs etc. will be preserved."
       echo
       echo "Would you like to proceed with the upgrade <Y/n>: \c"

       read type
       if [ "$type" = "y" -o "$type" = "Y" -o "$type" = "" ]; then
          echo
          # Check for any undo jobs(undo*.evm) and bail if they exist.
          if [ -f $EVMDIR/bin/jobs/undo*.evm ]; then
             echo "Detected existing \"undo\" jobs.  Please run any \"undo\" jobs"
             echo "under EVM 1.1 before upgrading to EVM 1.1A.  Exiting install."
             exit 1
          fi
          echo "Proceeding with EVM Upgrade..."
          cp $CURDIR/upgrade/evm $EVMDIR/bin/evm
          echo "Copied evm binary."
          cp $CURDIR/upgrade/findHbas.sh $EVMDIR/bin/findHbas.sh
          echo "Copied findHbas.sh scipt."
          cp $CURDIR/upgrade/tc_mon.frm $EVMDIR/html/tc_mon.frm
          echo "Copied tc_mon.frm data file."
          cp $CURDIR/README $EVMDIR/README
          cp $CURDIR/README $EVMDIR/docs/README
          cp $CURDIR/README.samples $EVMDIR/bin/samples/README
          echo "Copied README files."
          cp $CURDIR/upgrade/Sample_rc_script $EVMDIR/bin/samples/Sample_rc_script
          echo "Copied Sample_rc_script file."
          rm -R $EVMDIR/html/help
          cp -R $CURDIR/upgrade/help $EVMDIR/html
          echo "Copied help files."
          rm -R $EVMDIR/docs/EVM*
          rm -R $EVMDIR/docs/Heterogeneous-Storage-Area-Networks.pdf
          cp $CURDIR/docs/release_notes.pdf $EVMDIR/docs
          echo "Copied release notes."
          cp "$CURDIR/docs/EVM_1.1A_Solaris_IG_(AA-RLM1B-TE).pdf" $EVMDIR/docs
          echo "Copied install guide."

          # Check if cliwin is running, if so kill it before copying libcpqhmmo.so.
          cliwinpid=`ps -e | grep cliwin | grep -v grep | awk '{print $1}'`
          cliwinpid=${cliwinpid:-none}
          if [ $cliwinpid = "none" ]; then
              cp $CURDIR/upgrade/libcpqhmmo.so $EVMDIR/lib/libcpqhmmo.so
              echo "Copied libcpqhmmo.so library."
          else
              # Kill cliwin
              echo "Stopping CLI Script Window..."
              kill -9 $cliwinpid
              # Copy libcpqhmmo.so library
              cp $CURDIR/upgrade/libcpqhmmo.so $EVMDIR/lib/libcpqhmmo.so
              echo "Copied libcpqhmmo.so library."
              # Set CLIWIN_HOME var and re-start cliwin.
              CLI_DIR=`pkginfo -l CPQcliwin|grep BASEDIR|cut -d':' -f2`
              CLIWIN_HOME=$CLI_DIR;export CLIWIN_HOME
              echo "Starting CLI Script Window..."
              cd ${CLI_DIR}/bin
              nohup cliwin &
              cd $CURDIR
              sleep 3
          fi
          echo
          echo "Updating EVM version information..."
          cp /var/sadm/pkg/CPQevm/pkginfo /tmp/pkginfo
          cat /tmp/pkginfo|sed 's/VERSION=1.1/VERSION=1.1A/g' >/var/sadm/pkg/CPQevm/pkginfo
          rm /tmp/pkginfo

          # Check for Elm to see if we should upgrade.
          if [ "$ELM" = "1" ]; then
              echo
              echo "Proceeding with Elm Upgrade..."
              cp $CURDIR/upgrade/*.frm $ELMDIR/html
              cp $CURDIR/upgrade/*.jar $ELMDIR/html
              cp $CURDIR/upgrade/*.htm $ELMDIR/html
              cp $CURDIR/upgrade/*.gif $ELMDIR/html
              cp $CURDIR/upgrade/*.frm $ELMDIR/homepage
              cp $CURDIR/upgrade/*.jar $ELMDIR/homepage
              cp $CURDIR/upgrade/*.htm $ELMDIR/homepage
              cp $CURDIR/upgrade/*.gif $ELMDIR/homepage
              echo "Copied browser data files."
              echo "Updating Elm version information..."
              cp /var/sadm/pkg/CPQelm/pkginfo /tmp/pkginfo
              cat /tmp/pkginfo|sed 's/VERSION=1.6/VERSION=2.2.1/g' >/var/sadm/pkg/CPQelm/pkginfo
              rm /tmp/pkginfo
              echo
          fi

          # Check if hostname is NOT all lower case and
          # update the evm.ini file if this host is an EVM server.
          # This is because the steam connection requires a lower case hostname.
          swccSys=`echo $hostName|tr '[:upper:]' '[:lower:]'`
          if [ "$hostName" != "$swccSys" ]; then
              SWCC_INI_LINE=`grep stor1 $EVMDIR/bin/evm.ini`
              TokenCount=`echo $SWCC_INI_LINE|wc -w|awk ' { print $1 } '`
              if [ "$TokenCount" = "3" ]; then    # stor1 hostName subsysName
                  echo "Updating the EVM ini file..."
                  # Change the second token to lower case hostName(swccSys).
                  cp $EVMDIR/bin/evm.ini /tmp/evm.ini
                  cat /tmp/evm.ini|sed "s/stor1 $hostName/stor1 $swccSys/g" >$EVMDIR/bin/evm.ini
                  rm /tmp/evm.ini
                  echo
              fi
          fi


          echo "Upgrade Complete."
          echo
          echo "EVM 1.1A requires the environment variable \"EVM_HOME\" to point to"
          echo "the installed directory($EVMDIR).  The \"LD_LIBRARY_PATH\" environment"
          echo "variable should also be checked for the inclusion of \"${EVMDIR}/lib\"."
          echo "Please set both of these before starting EVM,"
          echo "or modify roots .profile(ksh) or .cshrc(csh) to set them at login."
          echo
          echo "Read the README file before running EVM."
          echo
          exit
       elif [ "$type" = "n" -o "$type" = "N" ]; then
          echo
          echo "Aborting upgrade script."
          exit 1
       fi
   done
else
   echo
   echo "ERROR: Invalid upgrade configuration detected."
   echo "In order to upgrade EVM, EVM version 1.1 must already"
   echo "be installed, and if present, the Elm version must be 1.6."
   echo "Please obtain an EVM 1.1A \"install\" CD"
   echo "to perform a new install of EVM."
   echo "Exiting upgrade script."
   exit 1
fi

if [ "$EVM" != "1" -o "$EVMVER" != "1.1" ]; then
   echo
   if [ "$EVM" = "1" -a "$EVMVER" = "1.1A" ]; then
      echo "EVM Version 1.1A already installed, aborting upgrade script."
      echo
   else
      echo
      echo "ERROR: Invalid upgrade configuration detected."
      echo "In order to upgrade EVM, EVM version 1.1  must already"
      echo "be installed.  Please obtain an EVM 1.1A \"install\" CD"
      echo "to perform a new install of EVM."
      echo "Exiting upgrade script."
      echo
   fi
   exit 1
fi

}


#------------------------------------------------------------------------------
displayinfo () {
echo
echo "EVM 1.1A is not backward compatible with EVM 1.1. You must upgrade "
echo "all of the EVM-enabled computers on the EVM Network. "
echo "You cannot mix EVM versions."
echo
echo "You should consider operational issues before starting to upgrade an "
echo "EVM Network: "
echo "-  EVM users have been notified of the planned upgrade."
echo "-  No EVM jobs are scheduled to run until after the upgrade."
echo "-  No EVM undo jobs exist when the upgrade is started."
echo "-  No EVM jobs are running during the upgrade."
echo "-  The EVM Server or Client program is not running during its upgrade."
echo 
echo "CAUTION: Failure to properly address operational issues prior to and "
echo "during upgrade of an EVM Network can lead to reduced operational capability"
echo "and loss of data."
echo 
echo "See the Installation Guide for more information."
echo
pause 
}

#------------------------------------------------------------------------------
checkevmrunning () {
evmpid=`ps -e | grep evm | grep -v grep | awk '{print $1}'`
evmpid=${evmpid:-none}
INPUT=""
if [ $evmpid != "none" ]; then
    while [ TRUE ]
    do
       echo "EVM currently running.  Terminate <Y/n>: \c"
       read INPUT
       if [ "$INPUT" = "y" -o "$INPUT" = "Y" -o "$INPUT" = "" ]; then
          echo "Stopping evm..."
          kill -9 $evmpid
          break
       elif [ "$INPUT" = "n" -o "$INPUT" = "N" ]; then
          echo "EVM cannot be running, exiting install."
          exit 1
       fi
    done
fi
}

#------------------------------------------------------------------------------
#Main
#-----------------------------------------------------------------------------
## Determine the platform running and setting host name
if [ $OSTYPE = "SunOS" ]; then
   hostName=`uname -n`
elif [ $OSTYPE = "OSF1" ]; then
   hostName=`uname -n | cut -d'.' -f1`
fi 

clear
copyright
checkuid
displayinfo
checkevmrunning
if [ $? = 1 ]
    then
        echo "exit"
        exit 1
fi  
 

# Determine the platform running
if [ $OSTYPE = "SunOS" ]; then
   # Check for correct platform kit:JNI driver and steam agent.
   CheckDriverVer 

   #check for previous install of elm, cliwin, evm
   solarispreinstallcheck

else
    echo
    echo "ERROR: This CD will run only on Solaris."
    exit
#elif [ $OSTYPE = "OSF1" ]; then
#   tru64preinstallcheck
fi 

echo
echo
echo "Upgrade Complete"
echo
echo "Read the README file before running EVM."
echo
exit 0
